#pragma once

#include "Components.h"

inline void hashCombine(int& seed, unsigned int& val) {
    seed ^= std::hash<unsigned int>()(val) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
};

inline int hashVal(const Edge& edge) {
    int seed = 0;
    unsigned int a = std::min(edge.m_edgeNodes.first, edge.m_edgeNodes.second);
    unsigned int b = std::max(edge.m_edgeNodes.first, edge.m_edgeNodes.second);
    hashCombine(seed, a);
    hashCombine(seed, b);
    return seed;
};

class Hash {
public:
    int operator()(const Edge& edge) const {
        return hashVal(edge);
    }
};